"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = conditionsMeet;

var _utils = require("./utils");

var _checkField = require("./checkField");

var _checkField2 = _interopRequireDefault(_checkField);

var _constants = require("./constants");

var _selectn = require("selectn");

var _selectn2 = _interopRequireDefault(_selectn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function conditionsMeet(condition, formData) {
  if (!(0, _utils.isObject)(condition) || !(0, _utils.isObject)(formData)) {
    (0, _utils.toError)("Rule " + JSON.stringify(condition) + " with " + formData + " can't be processed");
    return false;
  }
  return Object.keys(condition).every(function (ref) {
    var refCondition = condition[ref];
    if (ref === _constants.OR) {
      return refCondition.some(function (rule) {
        return conditionsMeet(rule, formData);
      });
    } else if (ref === _constants.AND) {
      return refCondition.every(function (rule) {
        return conditionsMeet(rule, formData);
      });
    } else if (ref === _constants.NOT) {
      return !conditionsMeet(refCondition, formData);
    } else {
      var refVal = (0, _selectn2.default)(ref, formData);
      if (Array.isArray(refVal)) {
        return refVal.some(function (val) {
          return conditionsMeet(refCondition, val);
        }) || (0, _checkField2.default)(refVal, refCondition);
      } else {
        return (0, _checkField2.default)(refVal, refCondition);
      }
    }
  });
}